#pragma once

#include <cstdint>

namespace BGTU::ComputerGraphicsLabWork::RendererApi {
	template<unsigned DIMENSIONS, class _component_t>
	class Point {
		static_assert(DIMENSIONS == 2 || DIMENSIONS == 3);
	};

	template<class _component_t>
	class Point<2, _component_t> {
	public:
		using component_t = _component_t;

		component_t x;
		component_t y;

		inline Point(component_t x, component_t y) : x{x}, y{y} {}

		template<class new_component_t, new_component_t (converter)(_component_t const &) = [](auto p) { return new_component_t(p); }>
		explicit operator Point<2, new_component_t>() const {
			return Point<2, new_component_t>{converter(this->x), converter(this->y)};
		}
	};

	template<class _component_t>
	class Point<3, _component_t> {
	public:
		using component_t = _component_t;

		component_t x;
		component_t y;
		component_t z;

		inline Point(component_t x, component_t y, component_t z) : x{x}, y{y}, z{z} {}


		template<class new_component_t>
		explicit operator Point<3, new_component_t>() const {
			return Point<3, new_component_t>{new_component_t{this->x}, new_component_t{this->y}, new_component_t{this->z}};
		}
	};

	template<unsigned DIMENSIONS>
	using PointI = Point<DIMENSIONS, long long>;

	template<unsigned DIMENSIONS>
	using PointF = Point<DIMENSIONS, double>;
}